#include "config.h"
#include <stdio.h>
#include <string.h>
#include <fcntl.h>

#define	TTYTIMEOUT	15

int changespeed(fd, baud)
     int fd;
     int baud;
{ 
	DCB dcb;
	DWORD Error;

	if (!GetCommState((HANDLE) fd, &dcb)) {
		Error = GetLastError();
		fprintf(stderr, " Can't get tty attribute.(%d)\n", Error);
		return(-1);
	}

	dcb.BaudRate = baud;
	dcb.ByteSize = 8;
	dcb.Parity = NOPARITY;;
	dcb.StopBits = ONESTOPBIT;
	dcb.fOutxCtsFlow = FALSE;
	dcb.fOutxDsrFlow = FALSE;
	dcb.fDtrControl = DTR_CONTROL_DISABLE;
	dcb.fRtsControl = RTS_CONTROL_DISABLE;
	dcb.fDsrSensitivity = FALSE;

	dcb.fOutX = FALSE;      
	dcb.fInX = FALSE;      
	dcb.fNull = FALSE;           

	if (!SetCommState((HANDLE) fd, &dcb)) {
		Error = GetLastError();
		fprintf(stderr, "Can't set tty attribute.(%d)\n",Error);
 		return(-1);
 	}
   	PurgeComm((HANDLE) fd, PURGE_RXABORT|PURGE_TXABORT|PURGE_RXCLEAR|PURGE_TXCLEAR);

	FlushFileBuffers((HANDLE) fd);

	return(1);
}

int opentty(tty)
     char *tty;
{
	DCB dcb;
	DWORD Error;
	COMMTIMEOUTS  CommTimeOuts ;
        HANDLE hCom;

	hCom = CreateFile(tty,
	   	GENERIC_READ | GENERIC_WRITE,
			  0,    
			  NULL, 
			  OPEN_EXISTING, 
			  FILE_ATTRIBUTE_NORMAL, 
			  NULL );

	if (hCom == INVALID_HANDLE_VALUE) {
    	Error = GetLastError();
	 	fprintf(stderr, "opentty fail(%d)\n", Error);
		return(-1);
	}


	memset(&CommTimeOuts, 0, sizeof(CommTimeOuts));
      CommTimeOuts.ReadIntervalTimeout = 0;
      CommTimeOuts.ReadTotalTimeoutMultiplier = 0;
      CommTimeOuts.ReadTotalTimeoutConstant = 1000 * TTYTIMEOUT;
      CommTimeOuts.WriteTotalTimeoutMultiplier = 0;
      CommTimeOuts.WriteTotalTimeoutConstant = 1000 * TTYTIMEOUT;
   if(!SetCommTimeouts( hCom, &CommTimeOuts )){
   	   	Error = GetLastError();
	 	fprintf(stderr, "set tty timeout fail(%d)\n", Error);
		return(-1);
	  }
 
	changespeed((int)hCom, 38400);
	Sleep(1000);

	return( (int) hCom);
}

int readtty(fd, p, c)
     int fd;
     unsigned char *p;
     int c;
{
	int readed = -1;
	DWORD	Error;

	if(ReadFile((HANDLE) fd, p, c, &readed, NULL)){
		if(c == 0)
			return(0);
		if(readed == 0)
			fprintf(stderr, "tty not respond.\n",readed , c);
		return(readed);
	}else{
	    Error = GetLastError();
		fprintf(stderr, "readtty fail(%d)\n", Error);
		return(-1);
	}
}

void flushtty(fd)
     int fd;
{
	PurgeComm((HANDLE) fd, PURGE_RXABORT|PURGE_TXABORT|PURGE_RXCLEAR|PURGE_TXCLEAR);
	FlushFileBuffers((HANDLE) fd);
	
	return;
}

int writetty(fd, p, c)
     int fd;
     unsigned char *p;
     int c;
{
	int written = 0;
	DWORD Error;

	if(WriteFile((HANDLE) fd, p, c, &written, NULL))
		return(written);
	else{
	    Error = GetLastError();
		fprintf(stderr, "write tty fail(%d)\n", Error);
		return(-1);
	}
}

int closetty(fd)
     int fd;
{
	return(CloseHandle((HANDLE) fd));
}

